'verzija s kalibracijo na 4 tockah
'ostale tocke racuna program



'narisemo tipke in prikljucimo Touch panel
'ta program uporabljamo za definicijo touch panela
'novi Touch Panel
's kalibracijo na 4 tipke


$regfile = "m32def.DAT"
$crystal = 8000000
'$crystal = 14456800
'$crystal = 11059200
'$crystal = 24000000
'$baud = 19200

'$loadersize = 512
$hwstack = 100
$swstack = 65
$framesize = 80
$lib "glcdKS108.lib"                                        'Include the library for the KS-108 controler


Config Graphlcd = 128 * 64sed , Dataport = Portc , Controlport = Portb , Ce = 0 , Ce2 = 1 , Cd = 2 , Rd = 3 , Reset = 5 , Enable = 4 , Mode = 8
'The dataport is the portname that is connected to the data lines of the LCD
'The controlport is the portname which pins are used to control the lcd
'CE =CS1  Chip select
'CE2=CS2  Chip select second chip
'CD=Data/instruction
'RD=Read
'RESET = reset
'ENABLE= Chip Enable
Cls

'____________________________________________________________________________ temp
Config 1wire = Portd.5

Dim T2 As Integer , T4 As Integer
Dim Ar(8) As Byte , N As Byte , V As Byte
Dim Bd(9) As Byte , S As Byte , S1 As Byte , Razl1 As Byte , Razl As Byte
Dim Tmp As Byte , T3 As Bit , Sekunde As Byte , Negirano As Byte
Dim Tn As Byte , Tb As Byte
Dim Tz As Byte , Minus As Bit


Dim Str1 As String * 80

'Deflcdchar 0 , 14 , 10 , 14 , 32 , 32 , 32 , 32 , 32        ' znak za stopinjo C

Const Timer1reload = 10800
Config Timer1 = Timer , Prescale = 1024
Load Timer1 , Timer1reload
On Ovf1 Timer1_isr
Enable Timer1
Start Timer1

Config Timer0 = Timer , Prescale = 64
Stop Timer0
On Ovf0 Tim0_sub
Enable Timer0



Enable Interrupts
'Add your code here

'Enable Int0
'Config Int1 = Low Level

'On Int0 Osvetlitev

'Config Watchdog = 2048


'Deflcdchar 4 , 10 , 4 , 14 , 17 , 16 , 17 , 14 , 32         ' mali 
Negirano = 0
S = 1                                                       'senzor st.
S1 = 1                                                      'zamenja sens.
V = 30                                                      'V je notr. temp-nastavljena
N = 35                                                      'Tz
Razl = 3                                                    'razlika
Razl1 = 15

'Cls
'Upperline
'Lcd "J.MIKELN - 2009"
'Lowerline
'Lcd "Krmilnik "
'Lcd Chr(4)
'Lcd "rpalke"
'Wait 2
'Cls

Dim Xx(9) As Byte
Dim T As Integer At Xx Overlay
Dim T1 As Integer
T = 0

'Cursor Off Noblink
Dim Sekundabit As Bit
Dim Osvetlitev As Byte , Osv As Bit , Sekundabit1 As Bit
Dim Luc As Byte , Luc_0 As Byte , Luc_1 As Byte

'______________________________________________________________________________


Config Adc = Single , Prescaler = Auto , Reference = Avcc   'Setting up the a/d convertor

Showpic 0 , 0 , Logose                                      'Svet elektronike  logo
Wait 1
Cls




Dim X As Word , Y As Word , I As Byte , Y1 As Word , Y2 As Word , X1 As Word , X2 As Word , Xa As Word , Xb As Word , Xc As Word , Xd As Word
Dim Ya As Word , Yb As Word , Yc As Word , Yd As Word , Narejeno As Bit , Tempx As Word , Tempy As Word

Dim Xy(16) As Word , Yx(16) As Word , Tabela As Word , I1 As Byte , J As Byte , Ind As Byte , K As Byte

'******** Funkcija, ki nam pove, e je oditana pozicija v dovoljenem obmoju okrog neke toke ******
'******** e je, se vrne z vrednostjo 1, drugae z vrednostjo 0 ******
'******** Funkciji podamo X in Y iskane toke, sama izrauna dovoljena odstopanja od te toke v x in y smeri *****
'******** Pred tem preberemo vrednosti pritiska X in Y  in ju zapiemo v Prebrano_x in Prebrano_y
'**** Izraunamo koordinate tirih tok, ki obkroajo dano toko *****
      Dim Min_x As Word , Max_x As Word
      Dim Min_y As Word , Max_y As Word


Dim Krk As Word , Tx As Byte , Tmpx As Byte
Dim Col As Byte , Row As Byte , Ty As Byte , Tcol As Word , Trow As Byte
Dim Skrk As String * 1 , Bkrk As Byte , L As Word           ', J As Byte

Declare Function Znotraj_obmocja(byval Ind As Byte) As Byte 'funkcija za Touch

Declare Sub _lcd(byval Bcol As Byte , Byval Brow As Byte , Byval Text As String)       'funkcija za tekst

'Config Portb = Output
'Portb = 255


'**** Prebrane oditke pritiska shranimo v ti dve spremenljivki ****
'**** Kasneje jih beremo v funkciji Znotraj_obmoja, kjer raziemo, ali je tipka pritisnjena ali ne
'Dim Prebrano_x As Word
'Dim Prebrano_y As Word
Const Offset_x = 6                                          ' +/- vrednosti odstopanja "X" za dovoljeno obmoje
'Const Offset_y = 4                                          ' +/- vrednost odstopanja "Y" za dovoljeno obmoje
Dim Pritisnjeno As Byte                                     '0, ce ni pritisnjena tipka

'Dim Tipka(17,2) As Word                                   'koordinate tok tipk

Dim Tipkax(17) As Eram Word
Dim Tipkay(17) As Eram Word
            '17 zato, da imam eno pom vr.
'Const Korak = 4
Dim Menilcd As Byte                                         'ce=3, >> gl. meni;=1>kolektor; =2>>bojler


Config Portd.0 = Input                                      'na zaetku s pritiskom na PortD0 izberemo kalibracijo
If Pind.0 = 0 Then
   Narejeno = 0
   Else
   Narejeno = 1
End If

'spremenljivka Narejeno doloca, ali smo ze naredili kalibracijo, Narejeno=0: kalibracija ni bila narejena

Setfont Font8x8
'Setfont Font5x5

Luc = 32

Start Adc                                                   ' Start the ad convertor
' =====Main=====
Main:

   Config Porta.4 = Output


Do

If Narejeno = 0 Then
   Gosub Kalibracija
   'Gosub Racunanje                                          'preracunaj tipke iz kalibracije
End If

Gosub Prit_tipke

Config Portd.1 = Input
If Pind.1 = 0 Then
   Gosub Prikazi_x
End If


If Osvetlitev > 4 Then
   Osvetlitev = 0
   Osv = 0                                                  'ugasnem osvetlitev
End If


If Osv = 1 Then                                             'ce pritisnemo
   Porta.4 = 1
   Luc = 64
   Disable Timer0
   Gosub Meritemp1                                          'merimo temperaturo ko je vklopljena osvetlitev
   Else
   Enable Timer0
   Stop Timer0
   If Luc > 1 Then Decr Luc
   Gosub Nastavi_luc
End If



Incr Sekunde                                                'as trajanja, ko osvetlitev GLCD-ja gori, potem pocasi ugasne
If Sekunde > 3 Then
   Sekunde = 0
End If


Gosub Compare

Loop

End

' Sledee definicije naj stojijo izza end ukaza
Term1:
'Data &H00 , &H10 , &HBC , &H14 , &H8C , &H00 , &H08 , &H00 , &H5F       ' , &H2D
Data &H00 , &H10 , &H28 , &H98 , &H65 , &H01 , &H08 , &H00 , &HA9       ' , &H2D
'Data &H00 , &H10 , &HD7 , &HA8 , &H65 , &H01 , &H08 , &H00 , &H7B       ' , &H2D


'       0       1     2       3     4       5    6       7       8
Term2:
Data &H00 , &H10 , &H10 , &HEF , &H8B , &H00 , &H08 , &H00 , &H2E
Term3:
Data &H00 , &H10 , &H9C , &H42 , &H65 , &H01 , &H08 , &H00 , &H91

Term4:
Data &H00 , &H10 , &H9C , &H42 , &H65 , &H01 , &H08 , &H00 , &H92

'//////////////////////////////////////////////////////////////////////////////


'----------------------------------------------------------------------------------------------------
'******** Funkcija, ki nam pove, e je oditana pozicija v dovoljenem obmoju okrog neke toke ******

Function Znotraj_obmocja(byval Ind As Byte) As Byte
           'zbriem dosedanjo vrednost te funkcije
          Znotraj_obmocja = 0
           Min_x = Tipkax(ind) - 5                          'Offsetx
           Max_x = Tipkax(ind) + 5                          'Offset_x
           Min_y = Tipkay(ind) - 85                         'Offset_y
           Max_y = Tipkay(ind) + 85                         'Offset_y

           '** Ali x ustreza ? ****
           If X >= Min_x And X <= Max_x Then
                   '** Ali ustreza tudi y? ****
                   If Y >= Min_y And Y <= Max_y Then
                   Znotraj_obmocja = 1
                   Else
                   Znotraj_obmocja = 0
                   End If
           End If

End Function
'--------------------------------------------------------------------------------------------------

Readtouch:

Y = 0
For J = 0 To 15                                             'beri touch

Config Porta.3 = Output                                     'pin1 (Y+)
Config Porta.1 = Output                                     ' PIN3 (Y-)
Set Porta.3                                                 'PIN2 (Y-)
Reset Porta.1                                               'PIN4 (Y+)
Config Pina.2 = Input                                       ' (X-)postavi kot vhod
Config Pina.0 = Input                                       ' (X+)

Waitus 1                                                    'pocakaj, da se port stabilizira
Y1 = Getadc(2)                                              ' (X-)
Y2 = 1024 - Y1
Y = Y2 + Y                                                  'preberi vrednost A/D
Next
Y = Y / 15
X = 0
For J = 0 To 15                                             'jo invertiraj

Config Porta.2 = Output                                     'ponovi isto za X koordinato
Config Porta.0 = Output                                     '
Reset Porta.2
Set Porta.0
Config Pina.1 = Input
Config Pina.3 = Input

Waitus 1
X1 = Getadc(1)                                              '
X2 = 1024 - X1
X = X2 + X
Next
X = X / 15
'J = 0
Return

'---------------------------------------------------------------------
'nastavitev postopno ugasanje osvetlitve

Svetleje:
   Stop Timer0
   If Luc < 64 Then Incr Luc
   Gosub Nastavi_luc
Return

Temneje:
   Stop Timer0
   If Luc > 0 Then Decr Luc
   Gosub Nastavi_luc
Return

Nastavi_luc:
   If Luc = 0 Then
      Reset Porta.4
   Elseif Luc > 63 Then
      Set Porta.4
   Else
      Luc_0 = Luc + 192
      Luc_1 = 256 - Luc
      Set Porta.4
      Tcnt0 = Luc_1
      Start Timer0
   End If
Return


'---------------------------------------------------------------------
'subrutina za kalibracijo tipk

Kalibracija:
I1 = 4
X = 0
Y = 0

_lcd 1 , 1 , "KALIBRACIJA"                                  ' ; Y ;
Wait 1
Cls
                                                      'samo pri kalibraciji=4
For I = 1 To 3 Step 1                                       ' Step 4                                      'Step 4                                      'Step 4
'--------------------------------------------------------------------------------------------------

Ponovi:
   Select Case I                                            'izpisujemo 4 slike da dobimo 4 kalibracijske tocke

   Case 1 : Showpic 0 , 0 , Bojler1
   Case 2 : Showpic 0 , 0 , Bojler2
   Case 3 : Showpic 0 , 0 , Bojler3

   End Select
   Wait 1

   Gosub Readtouch

   If X < 10 And Y < 10 Then
         Showpic 0 , 0 , Bojler_ni_ok
         Waitms 100
      Goto Ponovi


      Showpic 0 , 0 , Bojler_ni_ok
      Waitms 200
      Else
      Showpic 0 , 0 , Bojler_ok
      Waitms 100
   End If

   Tipkax(i) = X
   Tipkay(i) = Y

   Wait 1

   Waitms 200
Next I



 Narejeno = 1
Cls


I = 0

Return

'----------------------------------------------------------------------------------
'Prikaz pritisnjene tipke

Prit_tipke:


Gosub Readtouch


If X > 10 Or Y > 10 Then                                    'dodan pogoj,d a je tipka pritisnjena

Osvetlitev = 1                                              'vklopim osvetlitev ce je pritisnjena tipka
Osv = 1



For I = 1 To 5


Pritisnjeno = Znotraj_obmocja(i)


If Pritisnjeno = 1 Then                                     'ce se vrednost pritisnjeno ujema s shranjenimi

Select Case I                                               'prikazemo ustrezno sliko


Case 1 : Showpic 0 , 0 , Kolektor
'_lcd 70 , 8 , "Zunaj"                                       '1. tipka
_lcd 70 , 47 , "Nazaj"

Goto Naprej
Case 2 : Showpic 0 , 0 , Bojler_tmp
'_lcd 66 , 27 , "Bojler"                                     '2. tipka
_lcd 70 , 47 , "Nazaj"
Goto Naprej
Case 3 : Showpic 0 , 0 , Meni1
_lcd 66 , 27 , "Bojler"                                     '2. tipka
_lcd 62 , 8 , "Kolekt."                                     '1. tipka
_lcd 70 , 47 , "Zunaj"                                      '3. tipka



Naprej:

Menilcd = I
End Select

Exit For
End If

Next

Pritisnjeno = 0
End If

Waitms 30
Return

'--------------------------------------------------------------------------------------------------
'ce se ob resetu pritisne tipko Portd.1, se prikazejjo shranjene vrednosti touch koordinat

Prikazi_x:                                                  'pregled shranjenih koordinat

Cls
For I = 1 To 16
Tempx = Tipkax(i)
Tempy = Tipkay(i)
Prikazi:
Lcdat 1 , 1 , "I= " ; I ; "X= " ; Tempx ; "    "
Lcdat 2 , 1 , "Y= " ; Tempy ; "    "
Wait 1
Config Portd.2 = Input
   If Pind.2 = 0 Then                                       's pritiskom na tipko gremo na nasl. koordinato
   Next
   Else
   Goto Prikazi
End If
Return

'--------------------------------------------------------------------------------------------------
'subrutina za izpis karakterjev kjer koli na GLCD-ju

Sub _lcd(byval Bcol As Byte , Byval Brow As Byte , Byval Text As String)
    Col = Bcol
    Row = Brow
    L = Len(text)
    For J = 1 To L
       Skrk = Mid(text , J , 1)
       lds r24,{skrk}
       rcall _drawchar
    Next
End Sub


_drawchar:

 Lds r30 ,{___fonttable}                ; start of font data
 Lds r31 ,{___fonttable +1}

!  call _lpmbyte                          ; get Y bytes  1 for example
!  call _lpmbyte                          ; Get X Bytes , 8 For An 8 * 8 Font
!  call _lpmbyte                          ; get blocksize
MOV r16,r0 ; BLOCKSIZE

  adiw r30,1                             ; adjust for words

  subi r24,32                            ; chars start at 32 (space)
 ' ldi r16,16 ; 16 chars
  mov r20,r24
!  call _mul8                             ; get offset

  Add r30,r20                            ; add to start of font data
  Adc r31,r21                            ; Z now point to the first byte which is vertical aligned
    For Tx = 0 To 7                                         'do 4 za 5x5 , 7 za 8x8
!      call _lpmbyte                          ; firs data byte
      sts {krk},r0
'!     call _lpmbyte                          ; second
'      sts {krk+1},r0
      For Tmpx = 0 To 7                                     'do 4 za 5x5  7 za 8x8
          Tcol = Col + Tx
          Trow = Row + Tmpx
          If Krk.tmpx = 0 Then
             Pset Tcol , Trow , 0
          Else
             Pset Tcol , Trow , 1
          End If
      Next
    Next
  Col = Col + 9                                             '6 za 5x5, 9 za 8x8 itd...
ret

'--------------------------------------------------------------------------------------------------


Timer1_isr:
'Portd.3 = Not Portd.3
   Load Timer1 , Timer1reload
   Set Sekundabit
   Set Sekundabit1
   Incr Osvetlitev
Return


Tim0_sub:
   Stop Timer0
   Tcnt0 = Luc_0
   Luc_0 = Luc_1
   Luc_1 = Tcnt0
   Porta.4 = Not Porta.4
   Start Timer0
Return
'--------------------------------------------------------------------------------------------------
'nastavitev temperatur, ko crpalka vkljuci - to je za staro verzijo programa
'te subrutine ne klicem

Compare:
'Stop Watchdog
Config Portc.0 = Output
'Portc.0 = 0
If Sekunde > 2 Then
Portc.0 = 0                                                 ' rele ni vklopljen
   If Tn >= V Then                                          'notr. temp >= od V = notr.nast.temp.
      Portc.0 = 0
   '   Wait 1
   End If                                                   'rele se vklopi


   If Tn > Tz Then
      Razl = Tn - Tz
      Minus = 1                                             'minus
      Else
      Minus = 0                                             'plus
   End If

   If Tz > Tn Then
      Razl = Tz - Tn
      Select Case Razl                                      'nekaj avtomatskih nastavitev razlike
      'Case 35 To 40 : Razl1 = 30
      'Case 30 To 34 : Razl1 = 30
      'Case 25 To 29 : Razl1 = 25
      'Case 20 To 24 : Razl1 = 20
      'Case 17 To 25 : Razl1 = 12
      Case 9 To 50 : Razl1 = 8
      Case 7 : Razl1 = 10
      Case 4 : Razl1 = 2
      Case 1 To 2 : Razl1 = 4
                                    ' 4
      'Case 0 : Portc.0 = 1                                  'rocni vklop crpalke

      End Select
   End If

   If Razl >= Razl1 Then
      If Minus = 0 Then                                     'ce je razlika v plus, potem vklopi rele
         Portc.0 = 1
      End If
   '   Wait 1
      Else
'   If Tz >= N Then                                          'izm.temp.>= nast. zun. temp.
'      Portc.0 = 1
   '   Wait 1
'   End If
'      Else
      Portc.0 = 0
    End If
   '   Wait 1
'   End If
End If
'Start Watchdog
Return
'//////////////////////////////////////////////////////////////////////////////
Meritemp1:
If Sekundabit = 1 Then
     Reset Sekundabit

     ' Pripravimo Ident. 1. Termometra:
     For I = 1 To 8
         Xx(i) = Lookup(i , Term1)
     Next

     Disable Interrupts
     1wreset                                                'reset
     1wwrite &H55                                           'match ROM - izberi senzor DS1820
     1wwrite Xx(1) , 8                                      '1Wire ukaz
     1wwrite &HBE                                           'READ Scratchpad
     T = 1wread(9)
     1wreset
     Enable Interrupts
     T1 = T / 2
      'Lcdat 2 , 2 , T1 ; " C"
Select Case Menilcd
Case 1:                                                     'meni kolektor
      Str1 = Str(t1)                                        'pretvori spremenljivko v string

      _lcd 75 , 8 , Str1                                    'in jo prikazi na GLCD-ju
      Str1 = Chr(248)                                       'znak za Stopinjo C
      _lcd 96 , 8 , Str1
      _lcd 105 , 8 , "C"

Case 3:                                                     'ko smo v gl. meniju se izpis pomakne v levo

      Str1 = Str(t1)

      _lcd 15 , 8 , Str1
      Str1 = Chr(248)
      _lcd 36 , 8 , Str1
      _lcd 44 , 8 , "C"
 End Select

     ' Pripravimo Ident. 2. Termometra:
     For I = 1 To 8
         Xx(i) = Lookup(i , Term2)
     Next

     Disable Interrupts
     1wreset                                                'reset
     1wwrite &H55                                           'match ROM - izberi senzor DS1820
     1wwrite Xx(1) , 8                                      '1Wire ukaz
     1wwrite &HBE                                           'READ Scratchpad
     T = 1wread(9)
     1wreset
     Enable Interrupts
     T1 = T / 2

Select Case Menilcd
Case 2:                                                     'meni bojler
      Str1 = Str(t1)

      _lcd 75 , 27 , Str1
      Str1 = Chr(248)
      _lcd 96 , 27 , Str1
      _lcd 105 , 27 , "C"

Case 3:                                                     'ko smo v gl. meniju se izpis pomakne v levo
      Str1 = Str(t1)

      _lcd 15 , 27 , Str1
      Str1 = Chr(248)
      _lcd 36 , 27 , Str1
      _lcd 44 , 27 , "C"
End Select



     ' Pripravimo Ident. 3. Termometra:

     For I = 1 To 8
         Xx(i) = Lookup(i , Term3)
     Next

     Disable Interrupts
     1wreset                                                'reset
     1wwrite &H55                                           'match ROM - izberi senzor DS1820
     1wwrite Xx(1) , 8                                      '1Wire ukaz
     1wwrite &HBE                                           'READ Scratchpad
     T = 1wread(9)
     1wreset
     Enable Interrupts
     T1 = T / 2

Select Case Menilcd
Case 3:
      Str1 = Str(t1)

      _lcd 15 , 47 , Str1
      Str1 = Chr(248)
      _lcd 36 , 47 , Str1
      _lcd 44 , 47 , "C"
End Select

'      Str1 = Str(t1)

'      _lcd 72 , 47 , Str1
     'Locate 2 , 10
     'Lcd "T3= " ; T1 ; "C "

     Disable Interrupts
     1wreset
     1wwrite &HCC                                           'skip ROM
     1wwrite &H44                                           'convert temperature
     Enable Interrupts
End If
Return

'--------------------------------------------------------------------------------------------------
'slike

$include "font8x8.font"
'$include "font8x18.font"
Logose:
$bgf "logose.bgf"

Meni1:
$bgf "Meni1.bgf"

Kolektor:
$bgf "kolektor.bgf"

Bojler1:
$bgf "Bojler1.bgf"

Bojler2:
$bgf "Bojler2.bgf"
Bojler3:
$bgf "Bojler3.bgf"

Bojler4_menu:
$bgf "Bojler4_menu.bgf"

Bojler_tmp:
$bgf "Bojler_tmp.bgf"

Bojler_ok:
$bgf "Bojler_OK.bgf"

Bojler_ni_ok:
$bgf "Bojler_ni_OK.bgf"

Bojler_nazaj:
$bgf "Bojler_nazaj.bgf"