'verzija s kalibracijo na 4 tockah
'ostale tocke racuna program



'narisemo tipke in prikljucimo Touch panel
'ta program uporabljamo za definicijo touch panela
'novi Touch Panel
's kalibracijo na 4 tipke


$regfile = "m32def.DAT"
$crystal = 8000000
'$crystal = 14456800
'$crystal = 11059200
'$crystal = 24000000
'$baud = 19200

'$loadersize = 512
$hwstack = 100
$swstack = 75
$framesize = 40
$lib "glcdKS108.lib"                                        'Include the library for the KS-108 controler


Config Graphlcd = 128 * 64sed , Dataport = Portc , Controlport = Portb , Ce = 0 , Ce2 = 1 , Cd = 2 , Rd = 3 , Reset = 5 , Enable = 4 , Mode = 8
'The dataport is the portname that is connected to the data lines of the LCD
'The controlport is the portname which pins are used to control the lcd
'CE =CS1  Chip select
'CE2=CS2  Chip select second chip
'CD=Data/instruction
'RD=Read
'RESET = reset
'ENABLE= Chip Enable
Cls

Config Adc = Single , Prescaler = Auto , Reference = Avcc   'Setting up the a/d convertor

Showpic 0 , 0 , Logose                                      'Svet elektronike  logo
Wait 1
Cls




Dim X As Word , Y As Word , I As Byte , Y1 As Word , Y2 As Word , X1 As Word , X2 As Word , Xa As Word , Xb As Word , Xc As Word , Xd As Word,
Dim Ya As Word , Yb As Word , Yc As Word , Yd As Word , Narejeno As Bit , Tempx As Word , Tempy As Word

Dim Xy(16) As Word , Yx(16) As Word , Tabela As Word , I1 As Byte , J As Byte , Ind As Byte , K As Byte

'******** Funkcija, ki nam pove, e je oditana pozicija v dovoljenem obmoju okrog neke toke ******
'******** e je, se vrne z vrednostjo 1, drugae z vrednostjo 0 ******
'******** Funkciji podamo X in Y iskane toke, sama izrauna dovoljena odstopanja od te toke v x in y smeri *****
'******** Pred tem preberemo vrednosti pritiska X in Y  in ju zapiemo v Prebrano_x in Prebrano_y
'**** Izraunamo koordinate tirih tok, ki obkroajo dano toko *****
      Dim Min_x As Word , Max_x As Word
      Dim Min_y As Word , Max_y As Word


Declare Function Znotraj_obmocja(byval Ind As Byte) As Byte

'Config Portb = Output
'Portb = 255


'**** Prebrane oditke pritiska shranimo v ti dve spremenljivki ****
'**** Kasneje jih beremo v funkciji Znotraj_obmoja, kjer raziemo, ali je tipka pritisnjena ali ne
'Dim Prebrano_x As Word
'Dim Prebrano_y As Word
Const Offset_x = 6                                          ' +/- vrednosti odstopanja "X" za dovoljeno obmoje
'Const Offset_y = 4                                          ' +/- vrednost odstopanja "Y" za dovoljeno obmoje
Dim Pritisnjeno As Byte                                     '0, ce ni pritisnjena tipka

'Dim Tipka(17,2) As Word                                   'koordinate tok tipk

Dim Tipkax(17) As Eram Word
Dim Tipkay(17) As Eram Word
            '17 zato, da imam eno pom vr.
'Const Korak = 4

Config Portd.0 = Input                                      'na zaetku s pritiskom na PortD0 izberemo kalibracijo
If Pind.0 = 0 Then
   Narejeno = 0
   Else
   Narejeno = 1
End If

'spremenljivka Narejeno doloca, ali smo ze naredili kalibracijo, Narejeno=0: kalibracija ni bila narejena

Setfont Font8x8
Start Adc                                                   ' Start the ad convertor
' =====Main=====
Main:

Do
'Portb = 255
  If Narejeno = 0 Then
   Gosub Kalibracija
   Gosub Racunanje                                          'preracunaj tipke iz kalibracije
  End If

 Gosub Prit_tipke

Config Portd.1 = Input
If Pind.1 = 0 Then
   Gosub Prikazi_x
End If

Loop

End



'----------------------------------------------------------------------------------------------------
'******** Funkcija, ki nam pove, e je oditana pozicija v dovoljenem obmoju okrog neke toke ******

Function Znotraj_obmocja(byval Ind As Byte) As Byte
           'zbriem dosedanjo vrednost te funkcije
          Znotraj_obmocja = 0
           Min_x = Tipkax(ind) - 10                         'Offsetx
           Max_x = Tipkax(ind) + 10                         'Offset_x
           Min_y = Tipkay(ind) - 5                          'Offset_y
           Max_y = Tipkay(ind) + 5                          'Offset_y

           '** Ali x ustreza ? ****
           If X >= Min_x And X <= Max_x Then
                   '** Ali ustreza tudi y? ****
                   If Y >= Min_y And Y <= Max_y Then
                   Znotraj_obmocja = 1
                   Else
                   Znotraj_obmocja = 0
                   End If
           End If

End Function
'--------------------------------------------------------------------------------------------------

Readtouch:
Y = 0
For J = 0 To 15                                             'beri touch
Config Porta.3 = Output                                     'pin1 (Y+)
Config Porta.1 = Output                                     ' PIN3 (Y-)
Set Porta.3                                                 'PIN2 (Y-)
Reset Porta.1                                               'PIN4 (Y+)
Config Pina.2 = Input                                       ' (X-)postavi kot vhod
Config Pina.0 = Input                                       ' (X+)
Waitus 10                                                   'pocakaj, da se port stabilizira
Y1 = Getadc(2)                                              ' (X-)
Y2 = 1024 - Y1
Y = Y2 + Y                                                  'preberi vrednost A/D
Next
Y = Y / 15
X = 0
For J = 0 To 15                                             'jo invertiraj
Config Porta.2 = Output                                     'ponovi isto za X koordinato
Config Porta.0 = Output                                     '
Reset Porta.2
Set Porta.0
Config Pina.1 = Input
Config Pina.3 = Input
Waitus 10
X1 = Getadc(1)                                              '
X2 = 1024 - X1
X = X2 + X
Next
X = X / 15
'J = 0
Return

'---------------------------------------------------------------------
Kalibracija:
I1 = 4

Lcdat 1 , 1 , "KALIBRACIJA"                                 ' ; Y ;
Wait 1
Cls
                                                      'samo pri kalibraciji=4
For K = 1 To 4 Step 1                                       ' Step 4                                      'Step 4                                      'Step 4

Select Case K                                               'tukaj dolocimo kalibracijo samo v kotih
Case 1 : I = 1
Case 2 : I = 4
Case 3 : I = 13
Case 4 : I = 16

End Select

'--------------------------------------------------------------------------------------------------

Ponovi:
   Select Case I                                            'izpisujemo 4 slike da dobimo 4 kalibracijske tocke

   Case 1 : Showpic 0 , 0 , Tabela11
   Case 2 : Showpic 0 , 0 , Tabela12
   Case 3 : Showpic 0 , 0 , Tabela13
   Case 4 : Showpic 0 , 0 , Tabela14

   Case 5 : Showpic 0 , 0 , Tabela21
   Case 6 : Showpic 0 , 0 , Tabela22
   Case 7 : Showpic 0 , 0 , Tabela23
   Case 8 : Showpic 0 , 0 , Tabela24

   Case 9 : Showpic 0 , 0 , Tabela31
   Case 10 : Showpic 0 , 0 , Tabela32
   Case 11 : Showpic 0 , 0 , Tabela33
   Case 12 : Showpic 0 , 0 , Tabela34

   Case 13 : Showpic 0 , 0 , Tabela41
   Case 14 : Showpic 0 , 0 , Tabela42
   Case 15 : Showpic 0 , 0 , Tabela43
   Case 16 : Showpic 0 , 0 , Tabela44

   End Select
   Wait 1

   Gosub Readtouch
   Lcdat 3 , 30 , "X= " ; X                                 ' ; Y ;
   Lcdat 5 , 30 , "Y= " ; Y                                 ' ; Y ;

   If X < 10 And Y < 10 Then
         Showpic 0 , 0 , Tabela_ni_ok
         Waitms 100
      Goto Ponovi


      Showpic 0 , 0 , Tabela_ni_ok
      Waitms 200
      Else
      Showpic 0 , 0 , Tabela_ok
      Waitms 100
   End If

   Tipkax(i) = X
   Tipkay(i) = Y

   Wait 1

   Waitms 200
Next K



 Narejeno = 1
Cls


I = 0

Return

'----------------------------------------------------------------------------------
'Prikaz pritisnjene tipke

Prit_tipke:

'Showpic 0 , 0 , Tabela_v1


Gosub Readtouch


If X > 10 And Y > 10 Then                                   'dodan pogoj,d a je tipka pritisnjena

For I = 1 To 16


Pritisnjeno = Znotraj_obmocja(i)


If Pritisnjeno = 1 Then                                     'ce se vrednost pritisnjeno ujema s shranjenimi

Select Case I                                               'prikazemo ustrezno sliko


Case 1 : Showpic 0 , 0 , Tabela11
Case 2 : Showpic 0 , 0 , Tabela12
Case 3 : Showpic 0 , 0 , Tabela13
Case 4 : Showpic 0 , 0 , Tabela14
Case 5 : Showpic 0 , 0 , Tabela21
Case 6 : Showpic 0 , 0 , Tabela22
Case 7 : Showpic 0 , 0 , Tabela23
Case 8 : Showpic 0 , 0 , Tabela24
Case 9 : Showpic 0 , 0 , Tabela31
Case 10 : Showpic 0 , 0 , Tabela32
Case 11 : Showpic 0 , 0 , Tabela33
Case 12 : Showpic 0 , 0 , Tabela34
Case 13 : Showpic 0 , 0 , Tabela41
Case 14 : Showpic 0 , 0 , Tabela42
Case 15 : Showpic 0 , 0 , Tabela43
Case 16 : Showpic 0 , 0 , Tabela44

End Select

Exit For
End If

Next

Pritisnjeno = 0
End If

Return

'--------------------------------------------------------------------------------------------------

Prikazi_x:                                                  'pregled shranjenih koordinat

Cls
For I = 1 To 16
Tempx = Tipkax(i)
Tempy = Tipkay(i)
Prikazi:
Lcdat 1 , 1 , "I= " ; I ; "X= " ; Tempx ; "    "
Lcdat 2 , 1 , "Y= " ; Tempy ; "    "
Wait 1
Config Portd.2 = Input
   If Pind.2 = 0 Then                                       's pritiskom na tipko gremo na nasl. koordinato
   Next
   Else
   Goto Prikazi
End If
Return

'--------------------------------------------------------------------------------------------------


Racunanje:                                                  'izracun koordinat za tipke

I = 1

'tipka 2
Tempx = Tipkax(i) - Tipkax(i + 3)                           'pomozna vrednost
Tempx = Tempx / 3
Tempx = Tipkax(i) - Tempx
Tipkax(2) = Tempx


Tempy = Tipkay(i) - Tipkay(i + 3)                           'pomozna vrednost
Tempy = Tempy / 3
Tempy = Tipkay(i) - Tempy
Tipkay(2) = Tempy

'tipka 3
Tempx = Tipkax(i) - Tipkax(i + 3)                           'pomozna vrednost
Tempx = Tempx / 3
Tempx = Tipkax(i + 1) - Tempx
Tipkax(3) = Tempx

Tempy = Tipkay(i) - Tipkay(i + 3)                           'pomozna vrednost
Tempy = Tempy / 3
Tempy = Tipkay(i + 1) - Tempy
Tipkay(3) = Tempy

I = 13
'tipka 14
Tempx = Tipkax(i) - Tipkax(i + 3)                           'pomozna vrednost
Tempx = Tempx / 3
Tempx = Tipkax(i) - Tempx
Tipkax(14) = Tempx


Tempy = Tipkay(i) - Tipkay(i + 3)                           'pomozna vrednost
Tempy = Tempy / 3
Tempy = Tipkay(i) - Tempy
Tipkay(14) = Tempy

'tipka 15
Tempx = Tipkax(i) - Tipkax(i + 3)                           'pomozna vrednost
Tempx = Tempx / 3
Tempx = Tipkax(i + 1) - Tempx
Tipkax(15) = Tempx

Tempy = Tipkay(i) - Tipkay(i + 3)                           'pomozna vrednost
Tempy = Tempy / 3
Tempy = Tipkay(i + 1) - Tempy
Tipkay(15) = Tempy

'tipke 9, 10, 11, 12

For I = 9 To 12

Tempx = Tipkax(i + 4) - Tipkax(i - 8)                       'pomozna vrednost
Tempx = Tempx / 4
Tempx = Tipkax(i + 4) - Tempx
Tipkax(i) = Tempx


Tempy = Tipkay(i + 4) - Tipkay(i - 8)                       'pomozna vrednost
Tempy = Tempy / 4
Tempy = Tipkay(i + 4) - Tempy
Tipkay(i) = Tempy

Next I

'tipke 5,6,7,8

For I = 5 To 8

Tempx = Tipkax(i + 4) - Tipkax(i - 4)                       'pomozna vrednost
Tempx = Tempx / 2
Tempx = Tipkax(i + 4) - Tempx
Tipkax(i) = Tempx


Tempy = Tipkay(i + 4) - Tipkay(i - 4)                       'pomozna vrednost
Tempy = Tempy / 2
Tempy = Tipkay(i + 4) - Tempy
Tipkay(i) = Tempy

Next I

I = 0


Return

'--------------------------------------------------------------------------------------------------

End


'--------------------------------------------------------------------------------------------------
'slike

$include "font8x8.font"
Logose:
$bgf "logose.bgf"

Tipke:
$bgf "Tipke.bgf"



Tabela_v1:
$bgf "Tabela_v1.bgf"

Tabela11:
$bgf "Tabela11.bgf"

Tabela12:
$bgf "Tabela12.bgf"

Tabela13:
$bgf "Tabela13.bgf"

Tabela14:
$bgf "Tabela14.bgf"

Tabela_ok:
$bgf "Tabela_OK.bgf"

Tabela_ni_ok:
$bgf "Tabela_NI_OK.bgf"


Tabela21:
$bgf "Tabela21.bgf"

Tabela22:
$bgf "Tabela22.bgf"

Tabela23:
$bgf "Tabela23.bgf"

Tabela24:
$bgf "Tabela24.bgf"

Tabela31:
$bgf "Tabela31.bgf"

Tabela32:
$bgf "Tabela32.bgf"

Tabela33:
$bgf "Tabela33.bgf"

Tabela34:
$bgf "Tabela34.bgf"

Tabela41:
$bgf "Tabela41.bgf"

Tabela42:
$bgf "Tabela42.bgf"

Tabela43:
$bgf "Tabela43.bgf"

Tabela44:
$bgf "Tabela44.bgf"